MAKEALL 23 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862
  1. #!/bin/bash
  2. # Tool mainly for U-Boot Quality Assurance: build one or more board
  3. # configurations with minimal verbosity, showing only warnings and
  4. # errors.
  5. #
  6. # SPDX-License-Identifier: GPL-2.0+
  7. usage()
  8. {
  9. # if exiting with 0, write to stdout, else write to stderr
  10. local ret=${1:-0}
  11. [ "${ret}" -eq 1 ] && exec 1>&2
  12. cat <<-EOF
  13. Usage: MAKEALL [options] [--] [boards-to-build]
  14. Options:
  15. -a ARCH, --arch ARCH Build all boards with arch ARCH
  16. -c CPU, --cpu CPU Build all boards with cpu CPU
  17. -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
  18. -s SOC, --soc SOC Build all boards with soc SOC
  19. -b BOARD, --board BOARD Build all boards with board name BOARD
  20. -l, --list List all targets to be built
  21. -m, --maintainers List all targets and maintainer email
  22. -M, --mails List all targets and all affilated emails
  23. -C, --check Enable build checking
  24. -n, --continue Continue (skip boards already built)
  25. -r, --rebuild-errors Rebuild any boards that errored
  26. -h, --help This help output
  27. Selections by these options are logically ANDed; if the same option
  28. is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
  29. will select all configurations where the vendor is either FOO or
  30. BAR. Any additional arguments specified on the command line are
  31. always build additionally. See the boards.cfg file for more info.
  32. If no boards are specified, then the default is "powerpc".
  33. Environment variables:
  34. BUILD_NCPUS number of parallel make jobs (default: auto)
  35. CROSS_COMPILE cross-compiler toolchain prefix (default: "")
  36. CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
  37. architecture "ARCH". Substitute "ARCH" for any
  38. supported architecture (default: "")
  39. MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
  40. BUILD_DIR output build directory (default: ./)
  41. BUILD_NBUILDS number of parallel targets (default: 1)
  42. Examples:
  43. - build all Power Architecture boards:
  44. MAKEALL -a powerpc
  45. MAKEALL --arch powerpc
  46. MAKEALL powerpc
  47. - build all PowerPC boards manufactured by vendor "esd":
  48. MAKEALL -a powerpc -v esd
  49. - build all PowerPC boards manufactured either by "keymile" or "siemens":
  50. MAKEALL -a powerpc -v keymile -v siemens
  51. - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
  52. MAKEALL -c mpc83xx -v freescale 4xx
  53. EOF
  54. exit ${ret}
  55. }
  56. SHORT_OPTS="ha:c:v:s:b:lmMCnr"
  57. LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
  58. # Option processing based on util-linux-2.13/getopt-parse.bash
  59. # Note that we use `"$@"' to let each command-line parameter expand to a
  60. # separate word. The quotes around `$@' are essential!
  61. # We need TEMP as the `eval set --' would nuke the return value of
  62. # getopt.
  63. TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
  64. -n 'MAKEALL' -- "$@"`
  65. [ $? != 0 ] && usage 1
  66. # Note the quotes around `$TEMP': they are essential!
  67. eval set -- "$TEMP"
  68. SELECTED=''
  69. ONLY_LIST=''
  70. PRINT_MAINTS=''
  71. MAINTAINERS_ONLY=''
  72. CONTINUE=''
  73. REBUILD_ERRORS=''
  74. while true ; do
  75. case "$1" in
  76. -a|--arch)
  77. # echo "Option ARCH: argument \`$2'"
  78. if [ "$opt_a" ] ; then
  79. opt_a="${opt_a%)} || \$2 == \"$2\")"
  80. else
  81. opt_a="(\$2 == \"$2\")"
  82. fi
  83. SELECTED='y'
  84. shift 2 ;;
  85. -c|--cpu)
  86. # echo "Option CPU: argument \`$2'"
  87. if [ "$opt_c" ] ; then
  88. opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
  89. else
  90. opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
  91. fi
  92. SELECTED='y'
  93. shift 2 ;;
  94. -s|--soc)
  95. # echo "Option SoC: argument \`$2'"
  96. if [ "$opt_s" ] ; then
  97. opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
  98. else
  99. opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
  100. fi
  101. SELECTED='y'
  102. shift 2 ;;
  103. -v|--vendor)
  104. # echo "Option VENDOR: argument \`$2'"
  105. if [ "$opt_v" ] ; then
  106. opt_v="${opt_v%)} || \$5 == \"$2\")"
  107. else
  108. opt_v="(\$5 == \"$2\")"
  109. fi
  110. SELECTED='y'
  111. shift 2 ;;
  112. -b|--board)
  113. # echo "Option BOARD: argument \`$2'"
  114. if [ "$opt_b" ] ; then
  115. opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
  116. else
  117. # We need to check the 7th field too
  118. # for boards whose 6th field is "-"
  119. opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
  120. fi
  121. SELECTED='y'
  122. shift 2 ;;
  123. -C|--check)
  124. CHECK='C=1'
  125. shift ;;
  126. -n|--continue)
  127. CONTINUE='y'
  128. shift ;;
  129. -r|--rebuild-errors)
  130. REBUILD_ERRORS='y'
  131. shift ;;
  132. -l|--list)
  133. ONLY_LIST='y'
  134. shift ;;
  135. -m|--maintainers)
  136. ONLY_LIST='y'
  137. PRINT_MAINTS='y'
  138. MAINTAINERS_ONLY='y'
  139. shift ;;
  140. -M|--mails)
  141. ONLY_LIST='y'
  142. PRINT_MAINTS='y'
  143. shift ;;
  144. -h|--help)
  145. usage ;;
  146. --)
  147. shift ; break ;;
  148. *)
  149. echo "Internal error!" >&2 ; exit 1 ;;
  150. esac
  151. done
  152. GNU_MAKE=$(scripts/show-gnu-make) || {
  153. echo "GNU Make not found" >&2
  154. exit 1
  155. }
  156. # echo "Remaining arguments:"
  157. # for arg do echo '--> '"\`$arg'" ; done
  158. if [ ! -r boards.cfg ]; then
  159. echo "Could not find boards.cfg"
  160. tools/genboardscfg.py || {
  161. echo "Failed to generate boards.cfg" >&2
  162. exit 1
  163. }
  164. fi
  165. FILTER="\$1 !~ /^#/"
  166. [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
  167. [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
  168. [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
  169. [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
  170. [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
  171. if [ "$SELECTED" ] ; then
  172. SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
  173. # Make sure some boards from boards.cfg are actually found
  174. if [ -z "$SELECTED" ] ; then
  175. echo "Error: No boards selected, invalid arguments"
  176. exit 1
  177. fi
  178. fi
  179. #########################################################################
  180. # Print statistics when we exit
  181. trap exit 1 2 3 15
  182. trap print_stats 0
  183. # Determine number of CPU cores if no default was set
  184. : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
  185. if [ "$BUILD_NCPUS" -gt 1 ]
  186. then
  187. JOBS="-j $((BUILD_NCPUS + 1))"
  188. else
  189. JOBS=""
  190. fi
  191. if [ "${MAKEALL_LOGDIR}" ] ; then
  192. LOG_DIR=${MAKEALL_LOGDIR}
  193. else
  194. LOG_DIR="LOG"
  195. fi
  196. : ${BUILD_NBUILDS:=1}
  197. BUILD_MANY=0
  198. if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
  199. BUILD_MANY=1
  200. : ${BUILD_DIR:=./build}
  201. mkdir -p "${BUILD_DIR}/ERR"
  202. find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
  203. fi
  204. : ${BUILD_DIR:=.}
  205. OUTPUT_PREFIX="${BUILD_DIR}"
  206. [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
  207. if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
  208. find "${LOG_DIR}/" -type f -exec rm -f {} +
  209. fi
  210. LIST=""
  211. # Keep track of the number of builds and errors
  212. ERR_CNT=0
  213. ERR_LIST=""
  214. WRN_CNT=0
  215. WRN_LIST=""
  216. TOTAL_CNT=0
  217. SKIP_CNT=0
  218. CURRENT_CNT=0
  219. OLDEST_IDX=1
  220. RC=0
  221. # Helper funcs for parsing boards.cfg
  222. targets_by_field()
  223. {
  224. field=$1
  225. regexp=$2
  226. awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
  227. boards.cfg
  228. }
  229. targets_by_arch() { targets_by_field 2 "$@" ; }
  230. targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
  231. targets_by_soc() { targets_by_field 4 "$@" ; }
  232. #########################################################################
  233. ## MPC5xx Systems
  234. #########################################################################
  235. LIST_5xx="$(targets_by_cpu mpc5xx)"
  236. #########################################################################
  237. ## MPC5xxx Systems
  238. #########################################################################
  239. LIST_5xxx="$(targets_by_cpu mpc5xxx)"
  240. #########################################################################
  241. ## MPC512x Systems
  242. #########################################################################
  243. LIST_512x="$(targets_by_cpu mpc512x)"
  244. #########################################################################
  245. ## MPC8xx Systems
  246. #########################################################################
  247. LIST_8xx="$(targets_by_cpu mpc8xx)"
  248. #########################################################################
  249. ## PPC4xx Systems
  250. #########################################################################
  251. LIST_4xx="$(targets_by_cpu ppc4xx)"
  252. #########################################################################
  253. ## MPC824x Systems
  254. #########################################################################
  255. LIST_824x="$(targets_by_cpu mpc824x)"
  256. #########################################################################
  257. ## MPC8260 Systems (includes 8250, 8255 etc.)
  258. #########################################################################
  259. LIST_8260="$(targets_by_cpu mpc8260)"
  260. #########################################################################
  261. ## MPC83xx Systems (includes 8349, etc.)
  262. #########################################################################
  263. LIST_83xx="$(targets_by_cpu mpc83xx)"
  264. #########################################################################
  265. ## MPC85xx Systems (includes 8540, 8560 etc.)
  266. #########################################################################
  267. LIST_85xx="$(targets_by_cpu mpc85xx)"
  268. #########################################################################
  269. ## MPC86xx Systems
  270. #########################################################################
  271. LIST_86xx="$(targets_by_cpu mpc86xx)"
  272. #########################################################################
  273. ## 74xx/7xx Systems
  274. #########################################################################
  275. LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
  276. #########################################################################
  277. ## PowerPC groups
  278. #########################################################################
  279. LIST_TSEC=" \
  280. ${LIST_83xx} \
  281. ${LIST_85xx} \
  282. ${LIST_86xx} \
  283. "
  284. LIST_powerpc=" \
  285. ${LIST_5xx} \
  286. ${LIST_512x} \
  287. ${LIST_5xxx} \
  288. ${LIST_8xx} \
  289. ${LIST_824x} \
  290. ${LIST_8260} \
  291. ${LIST_83xx} \
  292. ${LIST_85xx} \
  293. ${LIST_86xx} \
  294. ${LIST_4xx} \
  295. ${LIST_74xx_7xx}\
  296. "
  297. # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
  298. # still using "ppc" instead of "powerpc"
  299. LIST_ppc=" \
  300. ${LIST_powerpc} \
  301. "
  302. #########################################################################
  303. ## StrongARM Systems
  304. #########################################################################
  305. LIST_SA="$(targets_by_cpu sa1100)"
  306. #########################################################################
  307. ## ARM7 Systems
  308. #########################################################################
  309. LIST_ARM7="$(targets_by_cpu arm720t)"
  310. #########################################################################
  311. ## ARM9 Systems
  312. #########################################################################
  313. LIST_ARM9="$(targets_by_cpu arm920t) \
  314. $(targets_by_cpu arm926ejs) \
  315. $(targets_by_cpu arm946es) \
  316. "
  317. #########################################################################
  318. ## ARM11 Systems
  319. #########################################################################
  320. LIST_ARM11="$(targets_by_cpu arm1136) \
  321. $(targets_by_cpu arm1176) \
  322. "
  323. #########################################################################
  324. ## ARMV7 Systems
  325. #########################################################################
  326. LIST_ARMV7="$(targets_by_cpu armv7)"
  327. #########################################################################
  328. ## ARMV8 Systems
  329. #########################################################################
  330. LIST_ARMV8="$(targets_by_cpu armv8)"
  331. #########################################################################
  332. ## AT91 Systems
  333. #########################################################################
  334. LIST_at91="$(targets_by_soc at91)"
  335. #########################################################################
  336. ## Xscale Systems
  337. #########################################################################
  338. LIST_pxa="$(targets_by_cpu pxa)"
  339. #########################################################################
  340. ## SPEAr Systems
  341. #########################################################################
  342. LIST_spear="$(targets_by_soc spear)"
  343. #########################################################################
  344. ## ARM groups
  345. #########################################################################
  346. LIST_arm="$(targets_by_arch arm | \
  347. for ARMV8_TARGET in $LIST_ARMV8; \
  348. do sed "/$ARMV8_TARGET/d"; \
  349. done) \
  350. "
  351. #########################################################################
  352. ## MIPS Systems (default = big endian)
  353. #########################################################################
  354. LIST_mips="$(targets_by_arch mips)"
  355. #########################################################################
  356. ## OpenRISC Systems
  357. #########################################################################
  358. LIST_openrisc="$(targets_by_arch openrisc)"
  359. #########################################################################
  360. ## x86 Systems
  361. #########################################################################
  362. LIST_x86="$(targets_by_arch x86)"
  363. #########################################################################
  364. ## Nios-II Systems
  365. #########################################################################
  366. LIST_nios2="$(targets_by_arch nios2)"
  367. #########################################################################
  368. ## MicroBlaze Systems
  369. #########################################################################
  370. LIST_microblaze="$(targets_by_arch microblaze)"
  371. #########################################################################
  372. ## ColdFire Systems
  373. #########################################################################
  374. LIST_m68k="$(targets_by_arch m68k)"
  375. LIST_coldfire=${LIST_m68k}
  376. #########################################################################
  377. ## AVR32 Systems
  378. #########################################################################
  379. LIST_avr32="$(targets_by_arch avr32)"
  380. #########################################################################
  381. ## Blackfin Systems
  382. #########################################################################
  383. LIST_blackfin="$(targets_by_arch blackfin)"
  384. #########################################################################
  385. ## SH Systems
  386. #########################################################################
  387. LIST_sh2="$(targets_by_cpu sh2)"
  388. LIST_sh3="$(targets_by_cpu sh3)"
  389. LIST_sh4="$(targets_by_cpu sh4)"
  390. LIST_sh="$(targets_by_arch sh)"
  391. #########################################################################
  392. ## SPARC Systems
  393. #########################################################################
  394. LIST_sparc="$(targets_by_arch sparc)"
  395. #########################################################################
  396. ## NDS32 Systems
  397. #########################################################################
  398. LIST_nds32="$(targets_by_arch nds32)"
  399. #########################################################################
  400. ## ARC Systems
  401. #########################################################################
  402. LIST_arc="$(targets_by_arch arc)"
  403. #-----------------------------------------------------------------------
  404. get_target_location() {
  405. local target=$1
  406. local BOARD_NAME=""
  407. local CONFIG_NAME=""
  408. local board=""
  409. local vendor=""
  410. # Automatic mode
  411. local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
  412. if [ -z "${line}" ] ; then echo "" ; return ; fi
  413. set ${line}
  414. CONFIG_NAME="${7%_defconfig}"
  415. [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
  416. if [ $# -gt 5 ]; then
  417. if [ "$6" = "-" ] ; then
  418. board=${BOARD_NAME}
  419. else
  420. board="$6"
  421. fi
  422. fi
  423. [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
  424. [ $# -gt 6 ] && [ "$8" != "-" ] && {
  425. tmp="${8%:*}"
  426. if [ "$tmp" ] ; then
  427. CONFIG_NAME="$tmp"
  428. fi
  429. }
  430. # Assign board directory to BOARDIR variable
  431. if [ "${vendor}" == "-" ] ; then
  432. BOARDDIR=${board}
  433. else
  434. BOARDDIR=${vendor}/${board}
  435. fi
  436. echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
  437. }
  438. get_target_maintainers() {
  439. local name=`echo $1 | cut -d : -f 3`
  440. local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
  441. if [ -z "${line}" ]; then
  442. echo ""
  443. return ;
  444. fi
  445. local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
  446. [ "$mails" == "-" ] && mails=""
  447. echo "$mails"
  448. }
  449. get_target_arch() {
  450. local target=$1
  451. # Automatic mode
  452. local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
  453. if [ -z "${line}" ] ; then echo "" ; return ; fi
  454. set ${line}
  455. echo "$2"
  456. }
  457. list_target() {
  458. if [ "$PRINT_MAINTS" != 'y' ] ; then
  459. echo "$1"
  460. return
  461. fi
  462. echo -n "$1:"
  463. local loc=`get_target_location $1`
  464. if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
  465. local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
  466. if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
  467. local dir=`echo ${loc} | cut -d ":" -f 2`
  468. local cfg=`echo ${loc} | cut -d ":" -f 1`
  469. local git_result=`git log --format=%aE board/${dir} \
  470. include/configs/${cfg}.h | grep "@"`
  471. local git_result_recent=`echo ${git_result} | tr " " "\n" | \
  472. head -n 3`
  473. local git_result_top=`echo ${git_result} | tr " " "\n" | \
  474. sort | uniq -c | sort -nr | head -n 3 | \
  475. sed "s/^ \+[0-9]\+ \+//"`
  476. echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
  477. sort -u | tr "\n" " " | sed "s/ $//" ;
  478. else
  479. echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
  480. sed "s/ $//" ;
  481. fi
  482. echo ""
  483. }
  484. # Each finished build will have a file called ${donep}${n},
  485. # where n is the index of the build. Each build
  486. # we've already noted as finished will have ${skipp}${n}.
  487. # The code managing the build process will use this information
  488. # to ensure that only BUILD_NBUILDS builds are in flight at once
  489. donep="${LOG_DIR}/._done_"
  490. skipp="${LOG_DIR}/._skip_"
  491. build_target_killed() {
  492. echo "Aborted $target build."
  493. # Remove the logs for this board since it was aborted
  494. rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
  495. exit
  496. }
  497. build_target() {
  498. target=$1
  499. build_idx=$2
  500. if [ "$ONLY_LIST" == 'y' ] ; then
  501. list_target ${target}
  502. return
  503. fi
  504. if [ $BUILD_MANY == 1 ] ; then
  505. output_dir="${OUTPUT_PREFIX}/${target}"
  506. mkdir -p "${output_dir}"
  507. trap build_target_killed TERM
  508. else
  509. output_dir="${OUTPUT_PREFIX}"
  510. fi
  511. target_arch=$(get_target_arch ${target})
  512. eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
  513. if [ "${cross_toolchain}" ] ; then
  514. MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
  515. elif [ "${CROSS_COMPILE}" ] ; then
  516. MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
  517. else
  518. MAKE=$GNU_MAKE
  519. fi
  520. if [ "${output_dir}" != "." ] ; then
  521. MAKE="${MAKE} O=${output_dir}"
  522. fi
  523. ${MAKE} distclean >/dev/null
  524. echo "Building ${target} board..."
  525. ${MAKE} -s ${target}_defconfig >/dev/null
  526. ${MAKE} ${JOBS} ${CHECK} all \
  527. >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
  528. # Check for 'make' errors
  529. if [ ${PIPESTATUS[0]} -ne 0 ] ; then
  530. RC=1
  531. fi
  532. if [ $BUILD_MANY == 1 ] ; then
  533. trap - TERM
  534. ${MAKE} -s clean
  535. if [ -s ${LOG_DIR}/${target}.ERR ] ; then
  536. cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
  537. else
  538. rm ${LOG_DIR}/${target}.ERR
  539. fi
  540. else
  541. if [ -s ${LOG_DIR}/${target}.ERR ] ; then
  542. if grep -iw error ${LOG_DIR}/${target}.ERR ; then
  543. : $(( ERR_CNT += 1 ))
  544. ERR_LIST="${ERR_LIST} $target"
  545. else
  546. : $(( WRN_CNT += 1 ))
  547. WRN_LIST="${WRN_LIST} $target"
  548. fi
  549. else
  550. rm ${LOG_DIR}/${target}.ERR
  551. fi
  552. fi
  553. OBJS=${output_dir}/u-boot
  554. if [ -e ${output_dir}/spl/u-boot-spl ]; then
  555. OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
  556. fi
  557. ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
  558. [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
  559. touch "${donep}${build_idx}"
  560. }
  561. manage_builds() {
  562. search_idx=${OLDEST_IDX}
  563. if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
  564. while true; do
  565. if [ -e "${donep}${search_idx}" ] ; then
  566. : $(( CURRENT_CNT-- ))
  567. [ ${OLDEST_IDX} -eq ${search_idx} ] &&
  568. : $(( OLDEST_IDX++ ))
  569. # Only want to count it once
  570. rm -f "${donep}${search_idx}"
  571. touch "${skipp}${search_idx}"
  572. elif [ -e "${skipp}${search_idx}" ] ; then
  573. [ ${OLDEST_IDX} -eq ${search_idx} ] &&
  574. : $(( OLDEST_IDX++ ))
  575. fi
  576. : $(( search_idx++ ))
  577. if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
  578. if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
  579. search_idx=${OLDEST_IDX}
  580. sleep 1
  581. else
  582. break
  583. fi
  584. fi
  585. done
  586. }
  587. build_targets() {
  588. for t in "$@" ; do
  589. # If a LIST_xxx var exists, use it. But avoid variable
  590. # expansion in the eval when a board name contains certain
  591. # characters that the shell interprets.
  592. case ${t} in
  593. *[-+=]*) list= ;;
  594. *) list=$(eval echo '${LIST_'$t'}') ;;
  595. esac
  596. if [ -n "${list}" ] ; then
  597. build_targets ${list}
  598. else
  599. : $((TOTAL_CNT += 1))
  600. : $((CURRENT_CNT += 1))
  601. rm -f "${donep}${TOTAL_CNT}"
  602. rm -f "${skipp}${TOTAL_CNT}"
  603. if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
  604. : $((SKIP_CNT += 1))
  605. touch "${donep}${TOTAL_CNT}"
  606. elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
  607. : $((SKIP_CNT += 1))
  608. touch "${donep}${TOTAL_CNT}"
  609. else
  610. if [ $BUILD_MANY == 1 ] ; then
  611. build_target ${t} ${TOTAL_CNT} &
  612. else
  613. CUR_TGT="${t}"
  614. build_target ${t} ${TOTAL_CNT}
  615. CUR_TGT=''
  616. fi
  617. fi
  618. fi
  619. # We maintain a running count of all the builds we have done.
  620. # Each finished build will have a file called ${donep}${n},
  621. # where n is the index of the build. Each build
  622. # we've already noted as finished will have ${skipp}${n}.
  623. # We track the current index via TOTAL_CNT, and the oldest
  624. # index. When we exceed the maximum number of parallel builds,
  625. # We look from oldest to current for builds that have completed,
  626. # and update the current count and oldest index as appropriate.
  627. # If we've gone through the entire list, wait a second, and
  628. # reprocess the entire list until we find a build that has
  629. # completed
  630. if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
  631. manage_builds
  632. fi
  633. done
  634. }
  635. #-----------------------------------------------------------------------
  636. kill_children() {
  637. local OS=$(uname -s)
  638. local children=""
  639. case "${OS}" in
  640. "Darwin")
  641. # Mac OS X is known to have BSD style ps
  642. local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
  643. children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
  644. ;;
  645. *)
  646. # everything else tries the GNU style
  647. local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
  648. children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
  649. ;;
  650. esac
  651. kill $children 2> /dev/null
  652. wait $children 2> /dev/null
  653. exit
  654. }
  655. print_stats() {
  656. if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
  657. # Only count boards that completed
  658. : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
  659. rm -f ${donep}* ${skipp}*
  660. if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
  661. ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
  662. ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
  663. ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
  664. WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
  665. WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
  666. WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
  667. else
  668. # Remove the logs for any board that was interrupted
  669. rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
  670. fi
  671. : $((TOTAL_CNT -= ${SKIP_CNT}))
  672. echo ""
  673. echo "--------------------- SUMMARY ----------------------------"
  674. if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
  675. echo "Boards skipped: ${SKIP_CNT}"
  676. fi
  677. echo "Boards compiled: ${TOTAL_CNT}"
  678. if [ ${ERR_CNT} -gt 0 ] ; then
  679. echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
  680. fi
  681. if [ ${WRN_CNT} -gt 0 ] ; then
  682. echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
  683. fi
  684. echo "----------------------------------------------------------"
  685. if [ $BUILD_MANY == 1 ] ; then
  686. kill_children
  687. fi
  688. exit $RC
  689. }
  690. #-----------------------------------------------------------------------
  691. # Build target groups selected by options, plus any command line args
  692. set -- ${SELECTED} "$@"
  693. # run PowerPC by default
  694. [ $# = 0 ] && set -- powerpc
  695. build_targets "$@"
  696. wait